Summary: The XEmacs editor
Name: xemacs
%define version 20.3
Version: %{version}
Release: 4
Copyright: GPL
Group: Applications/Editors/Emacs
Packager: Stig Bjrlykke <stigb@tihlde.hist.no>
Source0: xemacs-%{version}.tar.gz
Source1: xemacs-%{version}-info.tar.gz
Source2: xemacs-README.i386-pc-linux
Patch0: xemacs-%{version}-static.patch

# To avoid requirement for /usr/local/bin/perl
Patch1: xemacs-%{version}-gnudepend.patch
Patch2: xemacs-%{version}-hyperbole.patch
#
Url:http://www.xemacs.org/
Buildroot: /tmp/xemacs
#Prefix: /usr  # Can't have this with the /var/lock/xemacs directory :(

# initially by Stig Bjrlykke <stigb@tihlde.hist.no> for i386 
# and modified for sparc by Frederic Poncin <fp@info.ucl.ac.be>
# (who can make it run correctly on alpha?)

ExclusiveArch: i386 sparc

%description
XEmacs is a version of Emacs, compatible with and containing many 
improvements over FSF Emacs, written by Richard Stallman of the 
Free Software Foundation.  It was originally based on an early release 
of FSF Emacs Version 19, and has tracked subsequent releases of FSF 
Emacs as they have become available.
This XEmacs distribution has been splitted in some rpm :
- xemacs-%{version}        : the main part
- xemacs-el-%{version}     : elisp sources (optional)
- xemacs-static-%{version} : statically linked xemacs (optional)
- xemacs-extras-%{version} : files in conflict with emacs
(Install xemacs-extras if you do not have emacs installed.)

%package el
Summary: .el source files for XEmacs
Description: .el source files -- not necessary to run XEmacs
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}

%package static
Summary: static linked xemacs
Description: Static linked xemacs -- independent of the libraries installed
Group: Applications/Editors/Emacs
Requires: xemacs = %{version}

%package extras
Summary: files which conflict with FSF Emacs
Group: Applications/Editors/Emacs
Requires: xemacs
%description extras
These files are common between FSF Emacs and XEmacs. If you do not 
have FSF Emacs installed, be sure to install this package as well 
when you install XEmacs.


%prep
%setup -T -b 0 -n xemacs-%{version}
%setup -T -D -b 1 -n xemacs-%{version}
%patch0 -p1
%patch1 -p1
%patch2 -p1

%build

%ifarch i386
HOSTTYPE=i386-pc-linux
SOUND=native
%endif

%ifarch sparc
HOSTTYPE=sparc-unknown-linux
SOUND=none
%endif

#delete the originals for the patched files
find . -name "*.orig" -exec rm {} \;

./configure $HOSTTYPE --with-dialogs=athena  --with-sound=$SOUND \
            --cflags="$RPM_OPT_FLAGS" --error-checking=none      \
            --debug=no --prefix=/usr --lockdir=/var/lock/xemacs

make dist

#static build (only xemacs, not the others - gnuserv, movemail, gnuclient, ...)

# first, save the result of the dynamic build
mv src/xemacs xemacs-dynamic
# and ask for a new build
rm src/temacs

#on sparc, ld complain about __isnan of different size in libc.a and libm.a
#so ... forget de warning :-( ... -noinhibit-exec
#see xemacs-static.patch

%ifarch i386
cd src; make temacs-static-i386; cd ..
mv src/temacs-static-i386 src/temacs
%endif

%ifarch sparc
cd src; make temacs-static-sparc; cd ..
mv src/temacs-static-sparc src/temacs
%endif

#xemacs generation
make

%install

make prefix=$RPM_BUILD_ROOT/usr install-arch-dep 
make prefix=$RPM_BUILD_ROOT/usr install-arch-indep 
make prefix=$RPM_BUILD_ROOT/usr gzip-el 

mv $RPM_BUILD_ROOT/usr/bin/xemacs-%{version} \
   $RPM_BUILD_ROOT/usr/bin/xemacs-static
install -c -m755 xemacs-dynamic $RPM_BUILD_ROOT/usr/bin/xemacs-%{version}

cp $RPM_SOURCE_DIR/xemacs-README.i386-pc-linux README.i386-pc-linux
cp $RPM_SOURCE_DIR/xemacs-%{version}-static.patch xemacs-static.patch
mkdir -p -m 0777 $RPM_BUILD_ROOT/var/lock/xemacs

# Build file listings. (and make movemail setgid mail on RHL)

DIR="$RPM_BUILD_ROOT/usr/lib/xemacs-%{version}"
EL="*.el.gz"

find $DIR -type d |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) %dir #g" > rpm-files

find $DIR -name $EL -type f |
  sed -e "s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g" > rpm-el-files

find $DIR -not -name $EL -type f |
  sed -e "
    s#^$RPM_BUILD_ROOT\(.*movemail\)#%attr(2755, root, mail) \1#g
    s#^$RPM_BUILD_ROOT#%attr(-, root, root) #g
  " >> rpm-files

%clean
rm -rf $RPM_BUILD_ROOT

%files
%attr(-, root, root) %doc INSTALL README COPYING GETTING.GNU.SOFTWARE PROBLEMS 
%attr(-, root, root) %doc etc/NEWS etc/MAILINGLISTS BUGS README.i386-pc-linux
%attr(-, root, root) %doc Installation xemacs-static.patch
%attr(-, root, root) /usr/bin/xemacs
%attr(-, root, root) /usr/bin/xemacs-%{version}
%attr(-, root, root) /usr/bin/pstogif
%attr(-, root, root) /usr/bin/install-sid
%attr(-, root, root) /usr/bin/send-pr
%attr(-, root, root) /usr/bin/gnuclient
%attr(-, root, root) /usr/bin/gnuattach
%attr(-, root, root) /usr/bin/gnudoit
%attr(-, root, root) /usr/man/man1/xemacs.1
%attr(-, root, root) /usr/man/man1/gnuserv.1
%attr(-, root, root) /usr/man/man1/gnuclient.1
%attr(-, root, root) /usr/man/man1/gnuattach.1
%attr(-, root, root) /usr/man/man1/gnudoit.1
%attr(-, root, root) %dir /usr/lib/xemacs/
%attr(-, root, root) %dir /usr/lib/xemacs/site-lisp
%attr(-, root, root) %dir /var/lock/xemacs
%files -f rpm-files

%files el -f rpm-el-files

%files extras
%attr(-, root, root) /usr/bin/b2m
%attr(-, root, root) /usr/bin/ctags
%attr(-, root, root) /usr/bin/etags
%attr(-, root, root) /usr/bin/rcs-checkin
%attr(-, root, root) /usr/man/man1/ctags.1
%attr(-, root, root) /usr/man/man1/etags.1

%files static
%attr(-, root, root) /usr/bin/xemacs-static
